package ch.unige.aou.controller;

import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.controller.ModuleController;
import ch.unige.solidify.exception.SolidifyRuntimeException;

import ch.unige.aou.config.AouProperties;
import ch.unige.aou.repository.OAISetRepository;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.UrlPath;

@RestController
@ConditionalOnProperty(prefix = "aou.module.access", name = "enable")
@RequestMapping(UrlPath.ACCESS)
public class AccessController extends ModuleController {

  AccessController(AouProperties aouProperties, OAISetRepository oaiSetRepo) {
    super(ModuleName.ACCESS);

    // Module initialization
    if (aouProperties.getData().isInit()) {
      try {
        oaiSetRepo.init();
      } catch (final Exception e) {
        throw new SolidifyRuntimeException(e.getMessage());
      }
    }
  }
}
