package ch.unige.aou.controller.access;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.controller.ResourceController;
import ch.unige.solidify.security.AdminPermissions;

import ch.unige.aou.controller.AccessController;
import ch.unige.aou.model.oai.OAISet;
import ch.unige.aou.rest.UrlPath;

@RestController
@AdminPermissions
@ConditionalOnBean(AccessController.class)
@RequestMapping(UrlPath.ACCESS_OAI_SETS)
public class OAISetController extends ResourceController<OAISet> {

  /*
   * Override to benefit from permissions settings
   */
  @Override
  public HttpEntity<OAISet> create(@RequestBody OAISet oaiSet) {
    return super.create(oaiSet);
  }

  /*
   * Override to benefit from permissions settings
   */
  @Override
  public HttpStatus delete(@PathVariable String id) {
    return super.delete(id);
  }

  @Override
  public HttpStatus deleteList(@RequestBody String[] ids) {
    return super.deleteList(ids);
  }

  /*
   * Override to benefit from permissions settings
   */
  @Override
  public HttpEntity<OAISet> update(@PathVariable String id, @RequestBody OAISet oaiSet) {
    return super.update(id, oaiSet);
  }
}
