package ch.unige.aou.controller.admin;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.controller.ResourceController;
import ch.unige.solidify.rest.Collection;
import ch.unige.solidify.security.AdminPermissions;
import ch.unige.solidify.security.UserPermissions;

import ch.unige.aou.controller.AdminController;
import ch.unige.aou.model.publication.DocumentFileType;
import ch.unige.aou.rest.UrlPath;

@AdminPermissions
@RestController
@ConditionalOnBean(AdminController.class)
@RequestMapping(UrlPath.ADMIN_DOCUMENT_FILE_TYPES)
public class DocumentFileTypeController extends ResourceController<DocumentFileType> {

  @Override
  @UserPermissions
  public HttpEntity<Collection<DocumentFileType>> list(DocumentFileType search, Pageable pageable) {
    return super.list(search, pageable);
  }

  @Override
  public HttpEntity<DocumentFileType> get(@PathVariable String id) {
    return super.get(id);
  }

  @Override
  public HttpEntity<DocumentFileType> create(@RequestBody DocumentFileType documentFileType) {
    return super.create(documentFileType);
  }

  @Override
  public HttpEntity<DocumentFileType> update(@PathVariable String id, @RequestBody DocumentFileType documentFileType) {
    return super.update(id, documentFileType);
  }

  @Override
  public HttpStatus delete(@PathVariable String id) {
    return super.delete(id);
  }

  @Override
  public HttpStatus deleteList(@RequestBody String[] ids) {
    return super.deleteList(ids);
  }

}
