package ch.unige.aou.service;

import java.util.List;
import java.util.Map;

import ch.unige.solidify.rest.Resource;

public interface ResourceClientServiceInterface<T extends Resource<T>> {
  T create(T resource);

  void delete(String resId);

  void deleteList(String[] ids);

  List<T> findAll();

  T findOne(String resId);

  List<T> searchByProperties(Map<String, String> properties);

  T update(String resId, T resource);

}
