package ch.unige.aou.service.admin;

import java.nio.file.Path;
import java.util.List;

import org.springframework.core.io.Resource;

import ch.unige.aou.model.settings.Institution;
import ch.unige.aou.model.settings.Person;
import ch.unige.aou.service.ResourceClientServiceInterface;

public interface InstitutionClientServiceInterface extends ResourceClientServiceInterface<Institution> {
  public void addPerson(String institutionId, String personId);

  public List<Person> getPersons(String institutionId);

  /**
   * Remove Person from the institution
   */
  void removePerson(String institutionId, String personId);

  /**
   * Upload logo to an institution
   */
  Institution uploadLogo(String resId, Resource resource);

  /**
   * Download logo of an institution
   */
  void downloadLogo(String resId, Path path);

  /**
   * Delete logo of an institution
   */
  void deleteLogo(String resId);
}
