package ch.unige.aou.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.core.env.Environment;
import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.util.AbstractRestClientTool;

import ch.unige.aou.model.security.Role;
import ch.unige.aou.rest.ModuleName;
import ch.unige.aou.rest.ResourceName;
import ch.unige.aou.service.ResourceClientService;

@Service
public class RoleClientService extends ResourceClientService<Role> implements RoleClientServiceInterface {

  public RoleClientService(AbstractRestClientTool restClientTool, Environment env) {
    super(SolidifyConstants.URL_SEP + ResourceName.ROLES, Role.class, ModuleName.ADMIN, restClientTool, env);
  }

  @Override
  public List<Role> findAll() {
    return super.findAll(Role.class);
  }

  @Override
  public List<Role> searchByProperties(Map<String, String> properties) {
    return super.searchByProperties(properties, Role.class);
  }
}
