package ch.unige.aou.test;

import static ch.unige.aou.AouConstants.PERMANENT_TEST_DATA_LABEL;
import static org.junit.jupiter.api.Assertions.fail;

import java.util.concurrent.ThreadLocalRandom;

import ch.unige.solidify.util.SolidifyTime;

import ch.unige.aou.AouConstants;

public class AouTestConstants {
  public final static int TRIES = 120;
  public final static String STRUCTURE_PERMANENT = "Permanent Structure";
  public final static String RESEARCH_GROUP_PERMANENT = "Permanent Research Group";
  public final static String PUBLICATION_PERMANENT_STRUCTURE = "Permanent publication structure";
  public final static String PUBLICATION_PERMANENT_RESEARCH_GROUP = "Permanent publication research group";
  public final static String PUBLICATION_TYPE_PERMANENT = "Permanent publication type";
  public final static String PUBLICATION_SUB_TYPE_PERMANENT = "Permanent publication subtype";
  public final static String EVENT_MESSAGE_TEST = "Event message for testing";

  public static void failAfterNAttempt(int count, String failMessage) {
    if (count > AouTestConstants.TRIES) {
      fail(failMessage);
    }
    SolidifyTime.waitOneSecond();
  }

  public static String getNameWithPermanentLabel(String name) {
    return PERMANENT_TEST_DATA_LABEL + name;
  }

  public static String getRandomNameWithTemporaryLabel(String name) {
    return AouConstants.TEMPORARY_TEST_DATA_LABEL + name + ThreadLocalRandom.current().nextInt();
  }

  public static String getRandomOrcId() {
    String orcId = "";
    for (int i = 0; i < 4; i++) {
      for (int j = 0; j < 4; j++) {
        orcId = orcId + ThreadLocalRandom.current().nextInt(10);
      }
      orcId = orcId + "-";
    }
    return orcId.substring(0, orcId.length() - 1);
  }
}
