package ch.unige.aou.test.admin;

import static org.junit.jupiter.api.Assertions.assertEquals;

import ch.unige.aou.model.settings.License;
import ch.unige.aou.model.settings.LicenseGroup;

public abstract class LicenseIT extends AbstractAdminIT {

  protected LicenseGroup createTestLicenseGroup(String name) {
    this.restClientTool.sudoAdmin();
    LicenseGroup licenseGroup = new LicenseGroup();
    licenseGroup.setName(this.getTemporaryTestLabel(name));
    licenseGroup.setVisible(true);
    licenseGroup = this.licenseGroupService.create(licenseGroup);
    this.restClientTool.exitSudo();
    return licenseGroup;
  }

  protected License createTestLicense(LicenseGroup licenseGroup, String title, String openLicenseId, Integer sortValue) {
    this.restClientTool.sudoAdmin();
    License license = new License();
    license.setLicenseGroup(licenseGroup);
    license.setTitle(this.getTemporaryTestLabel(title));
    license.setOpenLicenseId(openLicenseId);
    license.setSortValue(sortValue);
    license = this.licenseService.create(license);
    this.restClientTool.exitSudo();
    return license;
  }

  protected void assertsLicense(License expectedLicense, License actualLicense) {
    assertEquals(expectedLicense.getLicenseGroup().getResId(), actualLicense.getLicenseGroup().getResId());
    assertEquals(expectedLicense.getTitle(), actualLicense.getTitle());
    this.assertEqualsWithoutNanoSeconds(expectedLicense.getCreationTime(), actualLicense.getCreationTime());
    assertEquals(expectedLicense.getOpenLicenseId(), actualLicense.getOpenLicenseId());
    assertEquals(expectedLicense.getSortValue(), actualLicense.getSortValue());
    assertEquals(expectedLicense.getUrl(), actualLicense.getUrl());
  }

  protected void assertsLicenseGroup(LicenseGroup expectedLicenseGroup, LicenseGroup actualLicenseGroup) {
    assertEquals(expectedLicenseGroup.getResId(), actualLicenseGroup.getResId());
    assertEquals(expectedLicenseGroup.getName(), actualLicenseGroup.getName());
    assertEquals(expectedLicenseGroup.getSortValue(), actualLicenseGroup.getSortValue());
    assertEquals(expectedLicenseGroup.getVisible(), actualLicenseGroup.getVisible());
  }

  @Override
  protected void deleteFixtures() {
    this.restClientTool.sudoAdmin();
    this.clearLicenceFixtures();
    this.clearLicenceGroupFixtures();
    this.restClientTool.exitSudo();
  }
}
