package ch.unige.aou.test.admin;

import java.util.List;

import ch.unige.aou.model.security.User;
import ch.unige.aou.model.settings.Person;
import ch.unige.aou.test.AouTestConstants;

public abstract class PersonIT extends AbstractAdminIT {

  protected final String ROLE_IDS_PROPERTY = "roleIds";

  protected Person createPerson(String firstName, String lastName, boolean orcid) {
    final Person person = new Person();
    person.setFirstName(AouTestConstants.getRandomNameWithTemporaryLabel(firstName));
    person.setLastName(AouTestConstants.getRandomNameWithTemporaryLabel(lastName));
    if (orcid) {
      person.setOrcid(AouTestConstants.getRandomOrcId());
    }
    return person;
  }

  protected boolean found(String search, String matchType, Person personToFound) {
    final List<Person> people = this.personService.search(search, matchType);
    for (final Person p : people) {
      if (p.getResId().equals(personToFound.getResId())) {
        return true;
      }
    }
    return false;
  }

  protected String getCurrentPersonId() {
    User currentUser = this.userService.getAuthenticatedUser();
    Person currentPerson = this.getLinkedPersonToUser(currentUser);
    return currentPerson.getResId();
  }

  @Override
  protected void deleteFixtures() {
    this.restClientTool.sudoRoot();
    this.clearPeopleFixtures();
    this.clearStructureFixtures();
    this.clearPersonNotificationTypes();
    this.restClientTool.exitSudo();
  }
}
