package ch.unige.aou.model.display;

import java.util.List;

import com.fasterxml.jackson.annotation.JsonProperty;

import ch.unige.solidify.rest.Relation3TiersChildDTO;
import ch.unige.solidify.rest.ResourceBase;
import ch.unige.solidify.util.ReflectionTool;

import ch.unige.aou.model.publication.PublicationSubtype;
import ch.unige.aou.model.settings.Structure;

public class StructureValidationRightDTO extends Structure implements Relation3TiersChildDTO<Structure, PublicationSubtype> {

  @JsonProperty("publicationSubtypes")
  List<PublicationSubtypeValidationRightDTO> grandChildren;

  public StructureValidationRightDTO(Structure structure, List<PublicationSubtypeValidationRightDTO> grandChildren) {
    ReflectionTool.copyFields(this, structure, ResourceBase.class);
    this.add(structure.getLinks());
    this.grandChildren = grandChildren;
  }

  @Override
  public List<PublicationSubtypeValidationRightDTO> getGrandChildren() {
    return this.grandChildren;
  }
}
