package ch.unige.aou.model.publication;

import java.util.Objects;

import ch.unige.solidify.util.StringTool;

public class ContributorDTO extends AbstractContributor {
  private String firstName;
  private String lastName;
  private String email;
  private String institution;
  private String role;
  private String orcid;
  private String cnIndividu;
  private String structure;

  public ContributorDTO() {
  }

  public ContributorDTO(String firstName, String lastName, String orcid, String cnIndividu) {
    this.firstName = firstName;
    this.lastName = lastName;
    this.orcid = orcid;
    this.cnIndividu = cnIndividu;
  }

  public String getFirstName() {
    return this.firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public String getLastName() {
    return this.lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  public String getEmail() {
    return this.email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public String getInstitution() {
    return this.institution;
  }

  public void setInstitution(String institution) {
    this.institution = institution;
  }

  public String getRole() {
    return this.role;
  }

  public void setRole(String role) {
    this.role = role;
  }

  public String getOrcid() {
    return this.orcid;
  }

  public void setOrcid(String orcid) {
    this.orcid = orcid;
  }

  public String getCnIndividu() {
    return this.cnIndividu;
  }

  public void setCnIndividu(String cnIndividu) {
    this.cnIndividu = cnIndividu;
  }

  public String getStructure() {
    return this.structure;
  }

  public void setStructure(String structure) {
    this.structure = structure;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || this.getClass() != o.getClass()) {
      return false;
    }

    ContributorDTO that = (ContributorDTO) o;

    if (!StringTool.isNullOrEmpty(this.cnIndividu) && Objects.equals(this.cnIndividu, that.cnIndividu)) {
      return true;
    }

    if (!StringTool.isNullOrEmpty(this.orcid) && Objects.equals(this.orcid, that.orcid)) {
      return true;
    }

    if (StringTool.isNullOrEmpty(this.cnIndividu) && StringTool.isNullOrEmpty(this.orcid)
            && StringTool.isNullOrEmpty(that.cnIndividu) && StringTool.isNullOrEmpty(that.orcid)) {
      // homonyms without any identifier are considered as the same person
      if (Objects.equals(this.firstName, that.firstName) && Objects.equals(this.lastName, that.lastName)) {
        return true;
      }
    }

    return false;
  }

  @Override
  public int hashCode() {
    return Objects.hash(firstName, lastName, orcid, cnIndividu);
  }
}
