package ch.unige.aou.model.publication;

import java.io.Serializable;
import java.util.Objects;
import javax.persistence.Embeddable;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import ch.unige.aou.AouConstants;
import ch.unige.aou.model.settings.Structure;

@Embeddable
public class PublicationStructureId implements Serializable {
    private static final long serialVersionUID = 2086021467257889857L;

    @ManyToOne
    @JoinColumn(name = AouConstants.DB_PUBLICATION_ID, referencedColumnName = AouConstants.DB_RES_ID)
    private Publication publication;

    @ManyToOne
    @JoinColumn(name = AouConstants.DB_STRUCTURE_ID, referencedColumnName = AouConstants.DB_RES_ID)
    private Structure structure;

    public Publication getPublication() {
        return publication;
    }

    public void setPublication(Publication publication) {
        this.publication = publication;
    }

    public Structure getStructure() {
        return structure;
    }

    public void setStructure(Structure structure) {
        this.structure = structure;
    }

    @Override
    public boolean equals(final Object other) {
        if (this == other) {
            return true;
        }
        if (!(other instanceof PublicationStructureId)) {
            return false;
        }
        final PublicationStructureId castOther = (PublicationStructureId) other;
        return Objects.equals(this.getPublication(), castOther.getPublication()) && Objects
                .equals(this.getStructure(), castOther.getStructure());
    }

    @Override
    public int hashCode() {
        return Objects.hash(this.getPublication(), this.getStructure());
    }

    @Override
    public String toString() {
        return this.getClass().getSimpleName() + ": " + AouConstants.DB_PUBLICATION_ID + "=" + this.getPublication().getResId() + " "
                + AouConstants.DB_STRUCTURE_ID + "=" + this.getStructure().getResId();
    }
}
