package ch.unige.aou.model.publication;

import java.io.Serializable;
import java.util.Objects;
import javax.persistence.Embeddable;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import ch.unige.aou.AouConstants;

@Embeddable
public class PublicationSubtypeDocumentFileTypePkId implements Serializable {
  private static final long serialVersionUID = 20860598719857L;

  @ManyToOne
  @JoinColumn(name = AouConstants.DB_PUBLICATION_SUBTYPE_ID)
  private PublicationSubtype publicationSubtype;

  @ManyToOne
  @JoinColumn(name = AouConstants.DB_DOCUMENT_FILE_TYPE_ID)
  private DocumentFileType documentFileType;

  public PublicationSubtype getPublicationSubtype() {
    return this.publicationSubtype;
  }

  public void setPublicationSubtype(PublicationSubtype publicationSubtype) {
    this.publicationSubtype = publicationSubtype;
  }

  public DocumentFileType getDocumentFileType() {
    return this.documentFileType;
  }

  public void setDocumentFileType(DocumentFileType documentFileType) {
    this.documentFileType = documentFileType;
  }

  @Override
  public boolean equals(final Object other) {
    if (this == other) {
      return true;
    }

    if (!(other instanceof PublicationSubtypeDocumentFileTypePkId)) {
      return false;
    }

    final PublicationSubtypeDocumentFileTypePkId castOther = (PublicationSubtypeDocumentFileTypePkId) other;
    return Objects.equals(this.getPublicationSubtype(), castOther.getPublicationSubtype()) && Objects
            .equals(this.getDocumentFileType(), castOther.getDocumentFileType());
  }

  @Override
  public int hashCode() {
    return Objects.hash(this.getPublicationSubtype(), this.getDocumentFileType());
  }
}
