package ch.unige.aou.model.publication;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.springframework.hateoas.server.mvc.WebMvcLinkBuilder;

import ch.unige.aou.model.AouResourceNormalized;
import ch.unige.aou.model.Sortable;
import ch.unige.aou.rest.ResourceName;

@Entity
public class PublicationType extends AouResourceNormalized<PublicationType> implements Sortable {

  /**
   * Type name (e.g: Article, Livre)
   */
  @Size(min = 1)
  @NotNull
  @Column(unique = true)
  private String name;

  /**
   * Property allowing to sort types in lists
   */
  @Column(nullable = false)
  private Integer sortValue;

  public String getName() {
    return this.name;
  }

  public void setName(String name) {
    this.setCurrentProperty(name);
  }

  @Override
  public Integer getSortValue() {
    return this.sortValue;
  }

  @Override
  public void setSortValue(Integer sort) {
    this.setCurrentProperty(sort);
  }

  @Override
  public void addLinks(WebMvcLinkBuilder linkBuilder, boolean mainRes, boolean subResOnly) {
    super.addLinks(linkBuilder, mainRes, subResOnly);
    if (mainRes) {
      this.add(linkBuilder.slash(this.getResId()).slash(ResourceName.PUBLICATION_SUBTYPES).withRel(ResourceName.PUBLICATION_SUBTYPES));
    }
  }
}
