package ch.unige.aou.model.rest;

import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonInclude;

public class OpenAireProjectDTO implements Serializable {
  private String program;
  private String code;
  private String acronym;
  private String title;
  private OpenAireFundingDTO funding = new OpenAireFundingDTO();

  public OpenAireProjectDTO() {
  }

  public OpenAireProjectDTO(String program, String code, String acronym, String title, OpenAireFundingDTO funding) {
    this.program = program;
    this.code = code;
    this.acronym = acronym;
    this.title = title;
    this.funding = funding;
  }

  public String getProgram() {
    return this.program;
  }

  public void setProgram(String program) {
    this.program = program;
  }

  public String getCode() {
    return this.code;
  }

  public void setCode(String code) {
    this.code = code;
  }

  public String getAcronym() {
    return this.acronym;
  }

  public void setAcronym(String acronym) {
    this.acronym = acronym;
  }

  public String getTitle() {
    return this.title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  @JsonInclude(JsonInclude.Include.NON_EMPTY)
  public OpenAireFundingDTO getFunding() {
    return this.funding;
  }

  public void setFunding(OpenAireFundingDTO funding) {
    this.funding = funding;
  }
}
