package ch.unige.aou.model.settings;

import java.util.Objects;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;

import ch.unige.solidify.rest.JoinResource;

import ch.unige.aou.model.publication.PublicationSubtype;

@Entity
@Table(name = "personValidationRightStructure")
public class ValidationRight extends JoinResource<ValidationRight, ValidationRightKey> {

  public final static String PATH_TO_PERSON = "compositeKey.person";
  public final static String PERSON_RELATION_PROPERTY_NAME = "validationRights";
  public final static String PATH_TO_STRUCTURE = "compositeKey.structure";
  public final static String STRUCTURE_RELATION_PROPERTY_NAME = "validationRights";
  public final static String PATH_TO_PUBLICATION_SUBTYPE = "compositeKey.publicationSubtype";

  @EmbeddedId
  @JsonIgnore
  private ValidationRightKey compositeKey;

  public ValidationRight() {
    this.compositeKey = new ValidationRightKey();
  }

  @Override
  public ValidationRightKey getCompositeKey() {
    return this.compositeKey;
  }

  @Override
  public void setCompositeKey(ValidationRightKey compositeKey) {
    this.compositeKey = compositeKey;
  }

  /*************************************************************************************/

  @JsonIgnore
  public Person getPerson() {
    return this.getCompositeKey().getPerson();
  }

  public void setPerson(Person person) {
    this.getCompositeKey().setPerson(person);
  }

  @JsonIgnore
  public Structure getStructure() {
    return this.getCompositeKey().getStructure();
  }

  public void setStructure(Structure structure) {
    this.getCompositeKey().setStructure(structure);
  }

  @JsonIgnore
  public PublicationSubtype getPublicationSubtype() {
    return this.getCompositeKey().getPublicationSubtype();
  }

  public void setPublicationSubtype(PublicationSubtype publicationSubtype) {
    this.getCompositeKey().setPublicationSubtype(publicationSubtype);
  }

  /*************************************************************************************/

  @Override
  public boolean equals(Object other) {
    if (this == other) {
      return true;
    }
    if (other == null || this.getClass() != other.getClass()) {
      return false;
    }

    ValidationRight castOther = (ValidationRight) other;
    return Objects.equals(this.getStructure(), castOther.getStructure())
            && Objects.equals(this.getPerson(), castOther.getPerson())
            && Objects.equals(this.getPublicationSubtype(), castOther.getPublicationSubtype());
  }

  @Override
  public int hashCode() {
    return Objects.hash(this.getStructure(), this.getPerson(), this.getPublicationSubtype());
  }

  /*************************************************************************************/
  /*************************************************************************************/

}
