package ch.unige.aou.model.xml.deposit.v2_2.serializer;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.SerializerProvider;
import com.fasterxml.jackson.databind.ser.std.StdSerializer;

import ch.unige.aou.model.xml.deposit.v2_2.AcademicStructure;
import ch.unige.aou.model.xml.deposit.v2_2.AcademicStructures;

public class AcademicStructuresSerializer extends StdSerializer<AcademicStructures> {
  public AcademicStructuresSerializer() {
    this(null);
  }

  public AcademicStructuresSerializer(Class<AcademicStructures> t) {
    super(t);
  }

  @Override
  public void serialize(AcademicStructures value, JsonGenerator jgen, SerializerProvider provider) throws IOException, JsonProcessingException {
    List<String> listStructureResId = new ArrayList<>();
    for (AcademicStructure academicStructure : value.getAcademicStructure()) {
      listStructureResId.add(academicStructure.getResId());
    }
    jgen.writeObject(listStructureResId);
  }
}
