package ch.unige.aou.model.xml.deposit.v2_3.deserializer;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.ObjectCodec;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ArrayNode;

import ch.unige.solidify.exception.SolidifyRuntimeException;

import ch.unige.aou.model.xml.deposit.AouStdDeserializer;
import ch.unige.aou.model.xml.deposit.v2_3.Keywords;

public class KeywordsDeserializer extends AouStdDeserializer<Keywords> {

  private static final long serialVersionUID = 659865L;

  @Override
  public Keywords deserialize(JsonParser parser, DeserializationContext context) throws IOException, JsonProcessingException {

    ObjectCodec codec = parser.getCodec();
    JsonNode jsonNode = codec.readTree(parser);

    if (jsonNode instanceof ArrayNode) {
      if (jsonNode.isEmpty()) {
        return null;
      }

      Keywords keywords = new Keywords();
      jsonNode.forEach(keywordNode -> {
        keywords.getKeyword().add(keywordNode.textValue());
      });
      return keywords;

    } else {
      throw new SolidifyRuntimeException("keywords is not an array");
    }
  }
}
