package ch.unige.aou.rest;

import ch.unige.solidify.SolidifyConstants;

public final class UrlPath {

  // @formatter:off
  
  // ==========
  // Access
  // ==========
  public static final String ACCESS = SolidifyConstants.URL_SEP + ModuleName.ACCESS;
  public static final String ACCESS_DOWNLOAD_TOKEN = ACCESS + SolidifyConstants.URL_SEP + ResourceName.DOWNLOAD_TOKEN;
  public static final String ACCESS_OAI_PROVIDER = ACCESS + SolidifyConstants.URL_SEP + ResourceName.OAI_PROVIDER;
  public static final String ACCESS_OAI_SETS = ACCESS + SolidifyConstants.URL_SEP + ResourceName.OAI_SETS;

  // ==========
  // Admin
  // ==========
  public static final String ADMIN = SolidifyConstants.URL_SEP + ModuleName.ADMIN;
  public static final String ADMIN_INSTITUTIONS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.INSTITUTIONS;
  public static final String ADMIN_LANGUAGES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.LANGUAGES;
  public static final String ADMIN_LICENSES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.LICENSES;
  public static final String ADMIN_LICENSE_GROUPS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.LICENSE_GROUPS;
  public static final String ADMIN_OAUTH2_CLIENTS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.OAUTH_2_CLIENTS;
  public static final String ADMIN_ORCID = ADMIN + SolidifyConstants.URL_SEP + ResourceName.ORCID;
  public static final String ADMIN_PEOPLE = ADMIN + SolidifyConstants.URL_SEP + ResourceName.PEOPLE;
  public static final String ADMIN_USERS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.USERS;
  public static final String ADMIN_SYSTEM_PROPERTIES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.SYSTEM_PROPERTIES;
  public static final String ADMIN_APPLICATION_ROLES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.APPLICATION_ROLES;
  public static final String ADMIN_PUBLICATIONS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.PUBLICATIONS;
  public static final String ADMIN_MODULES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.MODULES;
  public static final String ADMIN_MONITOR = ADMIN + SolidifyConstants.URL_SEP + ResourceName.MONITOR;
  public static final String ADMIN_PUBLICATION_TYPES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.PUBLICATION_TYPES;
  public static final String ADMIN_ROLES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.ROLES;
  public static final String ADMIN_AUTHOR_ROLES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.AUTHOR_ROLES;
  public static final String ADMIN_STRUCTURES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.STRUCTURES;
  public static final String ADMIN_RESEARCH_GROUPS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.RESEARCH_GROUPS;
  public static final String ADMIN_DOCUMENT_FILE_TYPES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.DOCUMENT_FILE_TYPES;
  public static final String ADMIN_PUBLICATION_SUBTYPES_DOCUMENT_FILE_TYPES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.PUBLICATION_SUBTYPES_DOCUMENT_FILE_TYPES;
  public static final String ADMIN_NOTIFICATIONS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.NOTIFICATIONS;
  public static final String ADMIN_EVENTS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.EVENTS;
  public static final String ADMIN_CONTRIBUTORS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.CONTRIBUTORS;
  public static final String ADMIN_PUBLICATION_SUBTYPES = ADMIN + SolidifyConstants.URL_SEP + ResourceName.PUBLICATION_SUBTYPES;
  public static final String ADMIN_EXTERNAL_DATA = ADMIN + SolidifyConstants.URL_SEP + ResourceName.EXTERNAL_DATA;
  public static final String ADMIN_SCHEDULED_TASKS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.SCHEDULED_TASKS;

  // =====================
  // Authorization Server
  // =====================
  public static final String AUTH = SolidifyConstants.URL_SEP + ModuleName.AUTH;
  public static final String AUTH_AUTHORIZE = AUTH + SolidifyConstants.URL_SEP + AouActionName.AUTHORIZE;
  public static final String AUTH_CHECK_TOKEN = AUTH + SolidifyConstants.URL_SEP + AouActionName.CHECK_TOKEN;
  public static final String AUTH_SHIBLOGIN = SolidifyConstants.URL_SEP + ResourceName.SHIBLOGIN;
  public static final String AUTH_TOKEN = AUTH + SolidifyConstants.URL_SEP + AouActionName.TOKEN;
  public static final String AUTH_USER_ID = "{" + AouActionName.USER_ID + "}";
  
  // @formatter on

  // ================
  // Resource Server
  // ================
  public static final String RES_SRV = SolidifyConstants.URL_SEP + ModuleName.RES_SRV;
  private UrlPath() {
    throw new IllegalStateException(SolidifyConstants.TOOL_CLASS);
  }

}
