package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.publication.DocumentFileType;

public class DocumentFileTypeSpecification extends SolidifySpecification<DocumentFileType> {

  public DocumentFileTypeSpecification(DocumentFileType criteria) {
    super(criteria);
  }

  @Override
  protected void completePredicatesList(Root<DocumentFileType> root, CriteriaQuery<?> query, CriteriaBuilder builder,
          List<Predicate> predicatesList) {
    if (this.criteria.getValue() != null) {
      predicatesList.add(builder.like(root.get("value"), "%" + this.criteria.getValue() + "%"));
    }
  }
}
