package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.settings.LicenseGroup;

public class LicenseGroupSpecification extends SolidifySpecification<LicenseGroup> {

  public LicenseGroupSpecification(LicenseGroup criteria) {
    super(criteria);
  }

  @Override
  protected void completePredicatesList(Root<LicenseGroup> root, CriteriaQuery<?> query, CriteriaBuilder builder,
          List<Predicate> predicatesList) {
    if (this.criteria.getName() != null) {
      predicatesList.add(builder.like(root.get("name"), "%" + this.criteria.getName() + "%"));
    }
    if (this.criteria.getSortValue() != null) {
      predicatesList.add(builder.equal(root.get("sortValue"), this.criteria.getSortValue()));
    }
    if (this.criteria.getVisible() != null) {
      predicatesList.add(builder.equal(root.get("visible"), this.criteria.getVisible()));
    }
  }
}
