package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;
import ch.unige.solidify.util.StringTool;

import ch.unige.aou.model.oai.OAISet;

public class OAISetSpecification extends SolidifySpecification<OAISet> {
  private static final long serialVersionUID = -8046624533135459649L;

  public OAISetSpecification(OAISet set) {
    super(set);
  }

  @Override
  protected void completePredicatesList(Root<OAISet> root, CriteriaQuery<?> query, CriteriaBuilder builder, List<Predicate> predicatesList) {
    if (!StringTool.isNullOrEmpty(this.criteria.getSpec())) {
      predicatesList.add(builder.like(root.get("spec"), "%" + this.criteria.getSpec() + "%"));
    }

    if (!StringTool.isNullOrEmpty(this.criteria.getName())) {
      predicatesList.add(builder.like(root.get("name"), "%" + this.criteria.getName() + "%"));
    }

    if (!StringTool.isNullOrEmpty(this.criteria.getDescription())) {
      predicatesList.add(builder.like(root.get("description"), "%" + this.criteria.getDescription() + "%"));
    }

    if (!StringTool.isNullOrEmpty(this.criteria.getQuery())) {
      predicatesList.add(builder.like(root.get("query"), "%" + this.criteria.getQuery() + "%"));
    }

    if (this.criteria.hasEnabledValue()) {
      Predicate p;
      if (this.criteria.isEnabled()) {
        p = builder.isTrue(root.get("enabled"));
      } else {
        p = builder.isFalse(root.get("enabled"));
      }
      predicatesList.add(p);
    }
  }
}
