package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.settings.Person;

public class PersonSpecification extends SolidifySpecification<Person> {
  private static final long serialVersionUID = -7232720336130296433L;

  public PersonSpecification(Person criteria) {
    super(criteria);
  }

  @Override
  protected void completePredicatesList(Root<Person> root, CriteriaQuery<?> query, CriteriaBuilder builder, List<Predicate> predicatesList) {
    if (this.criteria.getFirstName() != null) {
      predicatesList.add(builder.like(root.get("firstName"), "%" + this.criteria.getFirstName() + "%"));
    }
    if (this.criteria.getLastName() != null) {
      predicatesList.add(builder.like(root.get("lastName"), "%" + this.criteria.getLastName() + "%"));
    }
    if (this.criteria.getOrcid() != null) {
      predicatesList.add(builder.like(root.get("orcid"), "%" + this.criteria.getOrcid() + "%"));
    }
  }
}
