package ch.unige.aou.specification;

import java.util.List;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import ch.unige.solidify.specification.SolidifySpecification;

import ch.unige.aou.model.publication.PublicationSubtype;

public class PublicationSubtypeSpecification extends SolidifySpecification<PublicationSubtype> {
  private static final long serialVersionUID = -6165416319841641651L;

  public PublicationSubtypeSpecification(PublicationSubtype criteria) {
    super(criteria);
  }

  @Override
  protected void completePredicatesList(Root<PublicationSubtype> root, CriteriaQuery<?> query, CriteriaBuilder builder,
          List<Predicate> predicatesList) {
    if (this.criteria.getName() != null) {
      predicatesList.add(builder.like(root.get("name"), "%" + this.criteria.getName() + "%"));
    }
    if (this.criteria.getCode() != null) {
      predicatesList.add(builder.like(root.get("code"), "%" + this.criteria.getCode() + "%"));
    }
    if (this.criteria.getSortValue() != null) {
      predicatesList.add(builder.equal(root.get("sortValue"), this.criteria.getSortValue()));
    }
    if (this.criteria.getPublicationType() != null && this.criteria.getPublicationType().getResId() != null) {
      predicatesList.add(builder.equal(root.get("publicationType").get("resId"), this.criteria.getPublicationType().getResId()));
    }
  }
}
