package ch.unige.aou.test.tool;

import static org.junit.jupiter.api.Assertions.fail;

import java.io.IOException;
import java.net.URL;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.List;

import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.FileSystemResource;

import ch.unige.solidify.SolidifyConstants;

public abstract class AbstractXMLTest {

  protected Path getPath(String f) throws IOException {
    try {
      return new ClassPathResource(f).getFile().toPath();
    } catch (final IOException e) {
      return new FileSystemResource(f).getFile().toPath();
    }
  }

  protected List<URL> loadSchema(String xsdFile) {
    final List<URL> list = new ArrayList<>();
    try {
      final ClassPathResource xsd = new ClassPathResource(SolidifyConstants.SCHEMA_HOME + SolidifyConstants.URL_SEP + xsdFile);
      list.add(xsd.getURL());
    } catch (final IOException e) {
      fail(e.getMessage());
    }
    return list;
  }

}
