package ch.unige.aou.business;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import ch.unige.aou.model.notification.NotificationType;
import ch.unige.aou.repository.NotificationTypeRepository;
import ch.unige.aou.specification.NotificationTypeSpecification;

@Service
public class NotificationTypeService extends AouResourceService<NotificationType> {
  private static final Logger log = LoggerFactory.getLogger(NotificationTypeService.class);

  private NotificationTypeRepository notificationTypeRepository;

  public NotificationTypeService(NotificationTypeRepository notificationTypeRepository) {
    this.notificationTypeRepository = notificationTypeRepository;
  }

  @Override
  public NotificationTypeSpecification getSpecification(NotificationType resource) {
    return new NotificationTypeSpecification(resource);
  }

  public void initDefaultData() {
    for (NotificationType notificationType : NotificationType.getAllNotificationTypes()) {
      if (!this.notificationTypeRepository.findById(notificationType.getResId()).isPresent()) {
        this.notificationTypeRepository.save(notificationType);
        log.info("NotificationType {} created with event {}", notificationType.getResId(), notificationType.getEventType().getResId());
      }
    }
  }
}
