package ch.unige.aou.task;

import java.util.List;

import ch.unige.aou.business.NotificationService;
import ch.unige.aou.business.ScheduledTaskService;
import ch.unige.aou.model.notification.Notification;
import ch.unige.aou.model.notification.NotificationType;
import ch.unige.aou.model.schedule.ScheduledTask;

public class NotifyPublicationsToValidateTask extends AbstractTaskRunnable {

  public NotifyPublicationsToValidateTask(ScheduledTaskService scheduledTaskService, ScheduledTask scheduledTask,
          NotificationService notificationService, TaskExecutorService taskExecutorService) {
    super(scheduledTaskService, scheduledTask, notificationService, taskExecutorService);
  }

  @Override
  public void executeTask() {
    List<Notification> notificationsToSend = this.getNotificationsToSend(NotificationType.PUBLICATION_TO_VALIDATE);
    this.taskExecutorService.notifyPublicationsToValidate(notificationsToSend);
  }
}
