package ch.unige.aou.task;

import java.util.List;

import ch.unige.aou.business.NotificationService;
import ch.unige.aou.business.ScheduledTaskService;
import ch.unige.aou.model.notification.Notification;
import ch.unige.aou.model.notification.NotificationType;
import ch.unige.aou.model.schedule.ScheduledTask;

public class NotifyValidatorsOnCommentsTask extends AbstractTaskRunnable {

  public NotifyValidatorsOnCommentsTask(ScheduledTaskService scheduledTaskService, ScheduledTask scheduledTask,
          NotificationService notificationService, TaskExecutorService taskExecutorService) {
    super(scheduledTaskService, scheduledTask, notificationService, taskExecutorService);
  }

  @Override
  protected void executeTask() {
    List<Notification> notificationsToSend = this.getNotificationsToSend(NotificationType.PUBLICATION_TO_VALIDATE_COMMENTED);
    this.taskExecutorService.notifyValidatorsOnComments(notificationsToSend);
  }

}
